



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>谈谈一些有趣的CSS题目（四）-- 从倒影说起，谈谈 CSS 继承 inherit</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">谈谈一些有趣的CSS题目（四）-- 从倒影说起，谈谈 CSS 继承 inherit</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 03:02:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>开本系列，讨论一些有趣的 CSS 题目，抛开实用性而言，一些题目为了拓宽一下解决问题的思路，此外，涉及一些容易忽视的 CSS 细节。</p>
<p>解题不考虑兼容性，题目天马行空，想到什么说什么，如果解题中有你感觉到生僻的 CSS 属性，赶紧去补习一下吧。</p>
<p>不断更新，不断更新，不断更新，重要的事情说三遍。</p>
<p><a href="http://www.cnblogs.com/coco1s/p/5893921.html" rel="external nofollow noreferrer">谈谈一些有趣的CSS题目（一）-- 左边竖条的实现方法</a></p>
<p><a href="http://www.cnblogs.com/coco1s/p/5895764.html" rel="external nofollow noreferrer">谈谈一些有趣的CSS题目（二）-- 从条纹边框的实现谈盒子模型</a></p>
<p><a href="http://www.cnblogs.com/coco1s/p/5899089.html" rel="external nofollow noreferrer">谈谈一些有趣的CSS题目（三）-- 层叠顺序与堆栈上下文知多少</a></p>
<p>所有题目汇总在我的&nbsp;<a href="https://github.com/chokcoco/iCSS/issues/1" rel="external nofollow noreferrer">Github</a>&nbsp;。</p>
<h2>4、从倒影说起，谈谈 CSS 继承&nbsp;inherit</h2>
<p>给定一张有如下背景图的 div：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/608782/201609/608782-20160926101029078-1479229145.jpg" /></p>
<p>制作如下的倒影效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/608782/201609/608782-20160926101033719-863003334.png" /></p>
<p>方法很多，但是我们当然要寻找最快最便捷的方法，至少得是无论图片怎么变化，<code>div</code>&nbsp;大小怎么变化，我们都不用去改我们的代码。</p>
<h3>法一：-webkit-box-reflect</h3>
<p>这是一个十分新的 CSS 属性，使用起来十分简单，可以从各个方向反射我们内容。不过兼容性过于惨淡：</p>
<blockquote><p>基本上是只有 -webkit- 内核的浏览器才支持。</p></blockquote>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/608782/201609/608782-20160926102409016-393135122.png" /></p>
<p>不过使用起来真的是方便，解题如下：</p>
<div>
<pre class="prettyprint linenums">div{<br />
    -webkit-box-reflect: below;<br />
}</pre>
</div>
<p><a href="http://codepen.io/Chokcoco/pen/ORbvxJ" rel="external nofollow noreferrer">-webkit- 内核下查看Demo</a></p>
<p><code>box-reflect</code>&nbsp;有四个方向可以选，<code>below | above | left | right</code>&nbsp;代表下上左右，更具体的可以看看 <a href="https://developer.mozilla.org/zh-CN/docs/Web/CSS/-webkit-box-reflect" rel="external nofollow noreferrer">MDN</a> 。</p>
<h3>法二：inherit，使用继承</h3>
<p>本题主要还是为了介绍这种方法，兼容性好。</p>
<p><code>inherit</code>&nbsp;是啥，每个 CSS 属性定义的概述都指出了这个属性是默认继承的 ("Inherited: Yes") 还是默认不继承的 ("Inherited: no")。这决定了当你没有为元素的属性指定值时该如何计算值。</p>
<p>灵活使用&nbsp;<code>inherit</code>&nbsp;继承父值，可以解决许多看似复杂的问题。对于本题，我们对图片容器添加一个伪元素，使用&nbsp;<code>background-image:inherit</code>&nbsp;继承父值的背景图值，就可以做到无论图片如何变，我们的 CSS 代码都无需改动：</p>
<div>
<pre class="prettyprint linenums">div:before {<br />
    content: "";<br />
    position: absolute;<br />
    top: 100%;<br />
    left: 0;<br />
    right: 0;<br />
    bottom: -100%;<br />
    background-image: inherit;<br />
    transform: rotateX(180deg);;<br />
}</pre>
</div>
<p><a href="https://codepen.io/Chokcoco/pen/dppARA" rel="external nofollow noreferrer">Demo戳我</a></p>
<p>我们使用伪元素&nbsp;<code>background-image: inherit;</code>&nbsp;继承父元素的背景图，再使用 transform 旋转容器达到反射的效果。</p>
<blockquote><p>说到底，CSS 属性的取值就是由<strong>默认值（initial）</strong>，<strong>继承（inherit）</strong>与<strong>加权系统</strong>构成的（其实还有&nbsp;<code>unset(未设置)</code>、<code>revert(还原)</code>），厘清它们的关系及使用方法对熟练使用 CSS 大有裨益。</p></blockquote>
<p>所有题目汇总在我的&nbsp;<a href="https://github.com/chokcoco/iCSS/issues/1" rel="external nofollow noreferrer">Github</a>&nbsp;，发到博客希望得到更多的交流。</p>
<p>到此本文结束，如果还有什么疑问或者建议，可以多多交流，原创文章，文笔有限，才疏学浅，文中若有不正之处，万望告知。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvw4wj9.html">数据库设计 Assignment 02</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdm42vq.html">【HTML5】input类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yymneq.html">WCF入门教程（vs2010）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeel709.html">HTML5 localStorage and sessionStorage</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okk7de9.html">S1 ：数组迭代方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pwyj9.html">20150906VS小知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xwp2z9.html">&period;NET使用OpenSSL生成的pem密钥文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wk7loq.html">CSS3 绘制360安仔小精灵&lbrack;原创&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x751v8.html">cocos2d-x Touch</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok277e9.html">iOS8定位问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1k2zx8.html">安装会声会影x8后打不开的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnnr09.html">HTML学习（三）文本格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjevdz8.html">CENTOS6&period;6下mysql5&period;7&period;11带boost和不带boost的源码安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwmgz9.html">day43-python消息队列二-queue模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g0mzvq.html">多个Gesture响应原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdo4ke9.html">细说tomcat之集群session共享方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wgm1gq.html">kubernetes集群搭建（8）：常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj064zq.html">Java之数据流-复制二进制文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/902j27jq.html">Vue项目图片剪切上传&mdash;&mdash;vue-cropper的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpkzm49.html">【拉格朗日插值法】【找规律】【高精度】Gym - 101156G - Non-Attacking Queens</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/6o8k469j.html">启动了VSAN服务的主机不在vCenter集群中</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlmwk9o.html">C语言  &amp;&num;183&semi;  最大值与最小值计算</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pjr79x.html">angular实现统一的消息服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlj1e9o.html">HashMap与TreeMap源码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2jmx87.html">shell变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd5yz9d.html">interpreter&lpar;解释器模式&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/495jxmqz.html">Git 学习看这篇就够了！</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdodv8d.html">docker4dotnet &num;2 容器化主机</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gdy097.html">&lbrack;AlwaysOn Availability Groups&rsqb;健康模型 Part 1&mdash;&mdash;概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/495w7v9z.html">BZOJ 1391&colon; &lbrack;Ceoi2008&rsqb;order &lbrack;最小割&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
